<template lang="pug">
  ScreenWrapper(:loading="loading")
    .calculator
      .calculator__header
        ConverterInput(v-model.number="currentValue")
        CurrencyItem(:currency="baseCurrency")
          IconLink(icon="angle-down" :to="{ name: 'currency-settings' }")

      .calculator__body
        ConverterCurrencies(
          :currencies="currencies"
          :value="value"
        )
</template>

<script>
import {
  mapState, mapGetters, mapMutations, mapActions,
} from 'vuex';

import ConverterCurrencies from './components/ConverterCurrencies.vue';
import ConverterInput from './components/ConverterInput.vue';
import IconLink from '../../base/IconLink.vue';
import CurrencyItem from '../../common/CurrencyItem.vue';
import ScreenWrapper from '../../common/ScreenWrapper.vue';


export default {
  name: 'ConverterCalculator',

  components: {
    ScreenWrapper,
    ConverterCurrencies,
    ConverterInput,
    CurrencyItem,
    IconLink,
  },

  computed: {
    ...mapState('currency', [
      'loading',
      'baseCurrency',
    ]),

    ...mapState('calculator', [
      'value',
    ]),

    ...mapGetters('currency', [
      'currencies',
    ]),

    currentValue: {
      get() {
        return this.value;
      },
      set(value) {
        this.setValue(value);
      },
    },
  },

  async mounted() {
    await this.fetchCurrencyData();
  },

  methods: {
    ...mapActions('currency', [
      'fetchCurrencyData',
    ]),

    ...mapMutations('calculator', [
      'setValue',
    ]),
  },
};
</script>

<style lang="stylus" scoped>
.calculator__header
  position sticky
  top 0
  padding-top: env(safe-area-inset-top, 0)
  background-color var(--background-color)
  box-shadow 0 5px 5px 2px var(--shadow-color)
  z-index 1
  margin-bottom 10px
</style>
